<?php
// $Id: wfs_views.theme.inc,v 1.6.2.7 2010/04/27 15:04:34 tmcw Exp $

/**
 * @file
 * Theming functions for KML module views output.
 */

function template_preprocess_views_view_wfs(&$vars) {
  $view = $vars['view'];

  if (isset($_GET['request'])) {
    switch ($_GET['request']) { 
      case 'DescribeFeatureType':
        wfs_describefeaturetype($view);
    }
  }

  $points = $view->style_plugin->map_rows($vars['rows']);

  $rows = '';
  foreach ($points as $point) {
    $rows .= theme('wfs_placemark', $point, $view->name);
  }

  $vars['rows'] = $rows;
  $vars['viewtitle'] = $view->name;  

  drupal_set_header('Content-Type: text/xml');
}

/**
 * Called from the template preprocess
 * @param $view the view
 */
function wfs_describefeaturetype($view) {
  // A single view supports a single type, check that this is asking for it.
  if (isset($_GET['typename']) && 'drupal:'. $view->name != $_GET['typename']) {
    exit(theme('wfs_exception', 'NoApplicableCode',
      'Could not find type: {'. check_plain($_GET['typename']) .'}'));
  }

  drupal_set_header('Content-Type: text/xml; subtype=gml/3.1.1');
  exit(theme('wfs_describefeaturetype',
    $view->name, 
    $view->style_plugin->field_names()));
}

/**
 * Preprocess for theme('wfs_placemark').
 *
 * @param $vars a single placemark array
 */
function template_preprocess_wfs_placemark(&$vars) {  
  // TODO: don't rename in theme function
  $vars['coords'] = check_plain($vars['point']['point']);
  $vars['attr'] = $vars['point']['attr'];
  $vars['feature_id'] = $vars['point']['id'];
}
